## rehex 0.4.1

=== Makefile ===
# Reverse Engineer's Hex Editor
# Copyright (C) 2017-2021 Daniel Collins <solemnwarning@solemnwarning.net>
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 51
# Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

LUA          ?= lua
WX_CONFIG    ?= wx-config
CAPSTONE_PKG ?= capstone
JANSSON_PKG  ?= jansson
LUA_PKG      ?= $(shell pkg-config --exists lua5.3 && echo lua5.3 || echo lua)

EXE ?= rehex
EMBED_EXE ?= ./tools/embed
GTKCONFIG_EXE ?= ./tools/gtk-config

# Wrapper around the $(shell) function that aborts the build if the command
# exits with a nonzero status.
shell-or-die = $\
	$(eval sod_out := $$(shell $(1); echo $$$$?))$\
	$(if $(filter 0,$(lastword $(sod_out))),$\
		$(wordlist 1, $(shell echo $$(($(words $(sod_out)) - 1))), $(sod_out)),$\
		$(error $(1) exited with status $(lastword $(sod_out))))

WX_CXXFLAGS ?= $(call shell-or-die,$(WX_CONFIG) --cxxflags base core aui propgrid adv)
WX_LIBS     ?= $(call shell-or-die,$(WX_CONFIG) --libs     base core aui propgrid adv)

CAPSTONE_CFLAGS ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --cflags)
CAPSTONE_LIBS   ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --libs)

JANSSON_CFLAGS ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --cflags)
JANSSON_LIBS   ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --libs)

LUA_CFLAGS ?= $(call shell-or-die,pkg-config $(LUA_PKG) --cflags)
LUA_LIBS   ?= $(call shell-or-die,pkg-config $(LUA_PKG) --libs)

GTK_CFLAGS = $$($(GTKCONFIG_EXE) --cflags)
GTK_LIBS   = $$($(GTKCONFIG_EXE) --libs)

ifeq ($(DEBUG),)
	DEBUG=0
endif

ifeq ($(DEBUG),0)
	DEBUG_CFLAGS := -DNDEBUG
else
	DEBUG_CFLAGS := -ggdb
endif

CFLAGS          := -Wall -std=c99   -I. -Iinclude/ -IwxLua/modules/ $(DEBUG_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(CFLAGS)
CXXFLAGS_NO_GTK := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ $(DEBUG_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(CXXFLAGS)
CXXFLAGS        := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ $(DEBUG_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(GTK_CFLAGS) $(CXXFLAGS)

uname_S := $(shell uname -s 2>/dev/null)
ifeq ($(uname_S),FreeBSD)
	LDLIBS += -liconv
endif
ifeq ($(uname_S),OpenBSD)
	LDLIBS += -liconv
endif

LDLIBS := -lunistring $(WX_LIBS) $(GTK_LIBS) $(CAPSTONE_LIBS) $(JANSSON_LIBS) $(LUA_LIBS) $(LDLIBS)

# Define this for releases
VERSION := 0.4.1

ifdef VERSION
	LONG_VERSION := Version $(VERSION)
else
	# Check if we are actually in a git checkout before trying to get the
	# commit hash with `git log`, else we blow up in a git-archive export.
	
	ifneq ($(wildcard .git/*),)
		GIT_COMMIT_SHA ?= $(call shell-or-die,git log -1 --format="%H")
	else
		GIT_COMMIT_SHA ?= UNKNOWN
	endif
	
	GIT_COMMIT_TIME ?= $(call shell-or-die,git log -1 --format="%ct")
	
	VERSION      := 185c5df53fffdb6ea3625820fa3e3c6c35d57f2b
	LONG_VERSION := Snapshot 185c5df53fffdb6ea3625820fa3e3c6c35d57f2b
endif

DEPDIR := .d
DEPPRE = @mkdir -p "$(dir $(DEPDIR)/$@.Td)"
DEPFLAGS = -MT $@ -MMD -MP -MF $(DEPDIR)/$@.Td
DEPPOST = @mv -f $(DEPDIR)/$@.Td $(DEPDIR)/$@.d && touch $@

WXLUA_BINDINGS := wxLua/bindings/.done

.PHONY: all
all: $(EXE)

# Stop Make from deleting intermediate files at-will. Some intermediates (e.g. resources) are used
# by multiple targets (all and test) and so they should persist. Others are generated as a
# side-effect of another target (wxLua bindings) so Make cannot properly track how to build them
# when it needs to recreate them later.
.SECONDARY:

.PHONY: check
check: tests/all-tests
	./tests/all-tests

.PHONY: clean
clean:
	rm -f res/ascii16.c   res/ascii16.h \
	      res/ascii24.c   res/ascii24.h \
	      res/ascii32.c   res/ascii32.h \
	      res/ascii48.c   res/ascii48.h \
	      res/diff_fold16.c res/diff_fold16.h \
	      res/diff_fold24.c res/diff_fold24.h \
	      res/diff_fold32.c res/diff_fold32.h \
	      res/diff_fold48.c res/diff_fold48.h \
	      res/icon16.c    res/icon16.h \
	      res/icon32.c    res/icon32.h \
	      res/icon48.c    res/icon48.h \
	      res/icon64.c    res/icon64.h \
	      res/icon128.c   res/icon128.h \
	      res/license.c   res/license.h   res/license.done \
	      res/offsets16.c res/offsets16.h \
	      res/offsets24.c res/offsets24.h \
	      res/offsets32.c res/offsets32.h \
	      res/offsets48.c res/offsets48.h \
	      res/spinner24.c   res/spinner24.h
	
	rm -f $(APP_OBJS)
	rm -f $(EXE)
	rm -f $(TEST_OBJS)
	rm -f ./tests/all-tests
	rm -f $(EMBED_EXE)
	rm -f $(GTKCONFIG_EXE)
	
	grep -r "generated by genwxbind.lua" wxLua/ --exclude=genwxbind.lua | cut -d: -f1 | sort | uniq | xargs -r rm
	rm -f $(WXLUA_BINDINGS)
	
	rm -f src/lua-bindings/rehex_bind.done src/lua-bindings/rehex_bind.cpp src/lua-bindings/rehex_bind.h
	rm -f src/lua-plugin-preload.done src/lua-plugin-preload.c src/lua-plugin-preload.h

.PHONY: distclean
distclean: clean

WXLUA_OBJS := \
	wxLua/modules/wxlua/bit.o \
	wxLua/modules/wxlua/lbitlib.o \
	wxLua/modules/wxlua/wxlbind.o \
	wxLua/modules/wxlua/wxlcallb.o \
	wxLua/modules/wxlua/wxllua.o \
	wxLua/modules/wxlua/wxlobject.o \
	wxLua/modules/wxlua/wxlstate.o \
	wxLua/modules/wxlua/wxlua_bind.o

WXBIND_OBJS := \
	wxLua/modules/wxbind/src/wxadv_bind.o \
	wxLua/modules/wxbind/src/wxadv_wxladv.o \
	wxLua/modules/wxbind/src/wxaui_bind.o \
	wxLua/modules/wxbind/src/wxbase_base.o \
	wxLua/modules/wxbind/src/wxbase_bind.o \
	wxLua/modules/wxbind/src/wxbase_config.o \
	wxLua/modules/wxbind/src/wxbase_data.o \
	wxLua/modules/wxbind/src/wxbase_datetime.o \
	wxLua/modules/wxbind/src/wxbase_file.o \
	wxLua/modules/wxbind/src/wxcore_appframe.o \
	wxLua/modules/wxbind/src/wxcore_bind.o \
	wxLua/modules/wxbind/src/wxcore_clipdrag.o \
	wxLua/modules/wxbind/src/wxcore_controls.o \
	wxLua/modules/wxbind/src/wxcore_core.o \
	wxLua/modules/wxbind/src/wxcore_defsutils.o \
	wxLua/modules/wxbind/src/wxcore_dialogs.o \
	wxLua/modules/wxbind/src/wxcore_event.o \
	wxLua/modules/wxbind/src/wxcore_gdi.o \
	wxLua/modules/wxbind/src/wxcore_geometry.o \
	wxLua/modules/wxbind/src/wxcore_graphics.o \
	wxLua/modules/wxbind/src/wxcore_help.o \
	wxLua/modules/wxbind/src/wxcore_image.o \
	wxLua/modules/wxbind/src/wxcore_mdi.o \
	wxLua/modules/wxbind/src/wxcore_menutool.o \
	wxLua/modules/wxbind/src/wxcore_picker.o \
	wxLua/modules/wxbind/src/wxcore_print.o \
	wxLua/modules/wxbind/src/wxcore_sizer.o \
	wxLua/modules/wxbind/src/wxcore_windows.o \
	wxLua/modules/wxbind/src/wxcore_wxlcore.o \
	wxLua/modules/wxbind/src/wxpropgrid_bind.o

APP_OBJS := \
	res/ascii16.o \
	res/ascii24.o \
	res/ascii32.o \
	res/ascii48.o \
	res/diff_fold16.o \
	res/diff_fold24.o \
	res/diff_fold32.o \
	res/diff_fold48.o \
	res/icon16.o \
	res/icon32.o \
	res/icon48.o \
	res/icon64.o \
	res/icon128.o \
	res/license.o \
	res/offsets16.o \
	res/offsets24.o \
	res/offsets32.o \
	res/offsets48.o \
	res/spinner24.o \
	src/AboutDialog.o \
	src/AppMain.o \
	src/AppTestable.o \
	src/ArtProvider.o \
	src/BasicDataTypes.o \
	src/buffer.o \
	src/BytesPerLineDialog.o \
	src/ByteRangeSet.o \
	src/CharacterEncoder.o \
	src/ClickText.o \
	src/CodeCtrl.o \
	src/CommentTree.o \
	src/ConsoleBuffer.o \
	src/ConsolePanel.o \
	src/DataType.o \
	src/decodepanel.o \
	src/DiffWindow.o \
	src/disassemble.o \
	src/DisassemblyRegion.o \
	src/document.o \
	src/DocumentCtrl.o \
	src/EditCommentDialog.o \
	src/Events.o \
	src/FillRangeDialog.o \
	src/LicenseDialog.o \
	src/lua-bindings/rehex_bind.o \
	src/lua-plugin-preload.o \
	src/LuaPluginLoader.o \
	src/mainwindow.o \
	src/Palette.o \
	src/search.o \
	src/SelectRangeDialog.o \
	src/StringPanel.o \
	src/textentrydialog.o \
	src/Tab.o \
	src/ToolPanel.o \
	src/util.o \
	src/VirtualMappingDialog.o \
	src/VirtualMappingList.o \
	src/win32lib.o \
	$(WXLUA_OBJS) \
	$(WXBIND_OBJS) \
	$(EXTRA_APP_OBJS)

$(EXE): $(APP_OBJS) $(GTKCONFIG_EXE)
	$(CXX) $(CXXFLAGS) -DLONG_VERSION='"$(LONG_VERSION)"' -DLIBDIR='"$(libdir)"' -c -o res/version.o res/version.cpp
	$(CXX) $(CXXFLAGS) -o $@ $(APP_OBJS) res/version.o $(LDFLAGS) $(LDLIBS)

TEST_OBJS := \
	googletest/src/gtest-all.o \
	res/ascii16.o \
	res/ascii24.o \
	res/ascii32.o \
	res/ascii48.o \
	res/diff_fold16.o \
	res/diff_fold24.o \
	res/diff_fold32.o \
	res/diff_fold48.o \
	res/icon16.o \
	res/icon32.o \
	res/icon48.o \
	res/icon64.o \
	res/icon128.o \
	res/license.o \
	res/offsets16.o \
	res/offsets24.o \
	res/offsets32.o \
	res/offsets48.o \
	res/spinner24.o \
	src/AboutDialog.o \
	src/AppTestable.o \
	src/ArtProvider.o \
	src/BasicDataTypes.o \
	src/buffer.o \
	src/ByteRangeSet.o \
	src/BytesPerLineDialog.o \
	src/CharacterEncoder.o \
	src/ClickText.o \
	src/CommentTree.o \
	src/ConsoleBuffer.o \
	src/DataType.o \
	src/DiffWindow.o \
	src/DisassemblyRegion.o \
	src/document.o \
	src/DocumentCtrl.o \
	src/EditCommentDialog.o \
	src/Events.o \
	src/FillRangeDialog.o \
	src/LicenseDialog.o \
	src/lua-bindings/rehex_bind.o \
	src/lua-plugin-preload.o \
	src/LuaPluginLoader.o \
	src/mainwindow.o \
	src/Palette.o \
	src/search.o \
	src/SelectRangeDialog.o \
	src/StringPanel.o \
	src/Tab.o \
	src/textentrydialog.o \
	src/ToolPanel.o \
	src/util.o \
	src/VirtualMappingDialog.o \
	src/win32lib.o \
	tests/buffer.o \
	tests/ByteRangeMap.o \
	tests/ByteRangeSet.o \
	tests/CharacterEncoder.o \
	tests/CommentsDataObject.o \
	tests/CommentTree.o \
	tests/ConsoleBuffer.o \
	tests/DiffWindow.o \
	tests/DisassemblyRegion.o \
	tests/Document.o \
	tests/DocumentCtrl.o \
	tests/LuaPluginLoader.o \
	tests/main.o \
	tests/NestedOffsetLengthMap.o \
	tests/NumericTextCtrl.o \
	tests/search-bseq.o \
	tests/search-text.o \
	tests/SearchBase.o \
	tests/SearchValue.o \
	tests/SafeWindowPointer.o \
	tests/SharedDocumentPointer.o \
	tests/StringPanel.o \
	tests/Tab.o \
	tests/util.o \
	$(WXLUA_OBJS) \
	$(WXBIND_OBJS) \
	$(EXTRA_TEST_OBJS)

tests/all-tests: $(TEST_OBJS) $(GTKCONFIG_EXE)
	$(CXX) $(CXXFLAGS) -DLONG_VERSION='"$(LONG_VERSION)"' -DLIBDIR='"$(libdir)"' -c -o res/version.o res/version.cpp
	$(CXX) $(CXXFLAGS) -o $@ $(TEST_OBJS) res/version.o $(LDFLAGS) $(LDLIBS)

$(EMBED_EXE): tools/embed.cpp
	$(CXX) $(CXXFLAGS_NO_GTK) -o $@ $<

$(GTKCONFIG_EXE): tools/gtk-config.cpp
	$(CXX) $(CXXFLAGS_NO_GTK) $(WX_CXXFLAGS) -o $@ $<

src/AboutDialog.o: res/icon128.h
src/ArtProvider.o: \
	res/ascii16.h res/ascii24.h res/ascii32.h res/ascii48.h \
	res/diff_fold16.h res/diff_fold24.h res/diff_fold32.h res/diff_fold48.h \
	res/offsets16.h res/offsets24.h res/offsets32.h res/offsets48.h
src/DiffWindow.o: res/icon16.h res/icon32.h res/icon48.h res/icon64.h
src/LicenseDialog.o: res/license.h
src/LuaPluginLoader.o: src/lua-bindings/rehex_bind.h src/lua-plugin-preload.h
src/mainwindow.o: res/icon16.h res/icon32.h res/icon48.h res/icon64.h
src/StringPanel.o: res/spinner24.h

res/license.done: LICENSE.txt $(EMBED_EXE)
	$(EMBED_EXE) $< LICENSE_TXT res/license.c res/license.h
	touch $@

res/license.c res/license.h: res/license.done ;

res/%.c res/%.h: res/%.png $(EMBED_EXE)
	$(EMBED_EXE) $< $*_png res/$*.c res/$*.h

res/%.c res/%.h: res/%.gif $(EMBED_EXE)
	$(EMBED_EXE) $< $*_gif res/$*.c res/$*.h

src/lua-bindings/rehex_bind.done: src/lua-bindings/rehex.i src/lua-bindings/rehex_override.hpp src/lua-bindings/rehex_rules.lua $(WXLUA_BINDINGS)
	$(LUA) -e"rulesFilename=\"src/lua-bindings/rehex_rules.lua\"" wxLua/bindings/genwxbind.lua
	
	# genwxbind.lua may not modify individual files if they are already up to date.
	touch -c src/lua-bindings/rehex_bind.cpp
	touch -c src/lua-bindings/rehex_bind.h

=== debian/changelog ===
rehex (0.4.1-0~ubuntu2104) hirsute; urgency=low

  * Fixed font-dependent rendering glitches when control characters or other
    Unicode oddities were present in the text view.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 03 Jan 2022 16:58:31 +0000

rehex (0.4.0-0~ubuntu2104) hirsute; urgency=low

  * Add data types for common text encodings (Unicode, ISO-8859) - text
    displayed or typed into the text view on the right will be decoded or
    encoded appropriately (#10).

  * Treat pasted text as text rather than a string of raw bytes.

  * Add 8-bit integer data types.

  * Don't mark new files as unsaved.

  * Store cursor position history and allow jumping backwards/forwards (#81).

  * Allow jumping to previous/next difference in data compare window (#131).

  * Collapse long ranges of identical data in data compare window (#85).

  * Added "Jump to offset in main window" to data compare window context menu.

  * Added shortcuts for comparing data (#103).

  * Add support for other encodings to strings tool (#106).

  * Add write protect flag to prevent accidental changes to file data during
    analysis (#130).

  * Respect system cursor blink speed setting (#112).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 20 Dec 2021 17:48:20 +0000

rehex (0.3.92-0~ubuntu2104+1) hirsute; urgency=low

  * Fix broken runtime depedency (libcapstone3 -> libcapstone4).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Wed, 25 Aug 2021 20:54:35 +0100

rehex (0.3.92-0~ubuntu2104) hirsute; urgency=low

  * Reduce persistent memory usage (#52).

  * Fully undo virtual mapping changes in one step (#126).

  * Fix build dependency errors (#129).

  * Add "Find previous" button to search dialogs (#111).

  * Fix hard-to-see colours in "Decode values" panel on some systems (#127).

  * Fix build errors on FreeBSD (#133).

  * Prevent document from jumping around when the window is resized or
    disassembly is in progress (#132).

  * Fix build errors when using wxWidgets 3.1.5 and newer.

  * Refactor selection handling to make sense in virtual section view (#125).

  * Add font face setting to "View" menu (#128).

  * Correctly track whether files have been modified since saving (#122).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Tue, 24 Aug 2021 22:50:23 +0100

rehex (0.3.91-0~ubuntu2104) hirsute; urgency=low

  * Fix loading of plugins bundled as part of an AppImage.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 03 May 2021 14:06:29 +0100

rehex (0.3.90-0~ubuntu2104) hirsute; urgency=low

  * Show disassembly of machine code in the main document view (#94).

  * Add font size settings to "View" menu (#97).

  * Add float/double types to "Set data type" menu (#104).

  * Fix selection by holding shift and clicking (#109).

  * Initial support for Lua plugins.

  * Process sections from PE EXE/DLL headers (#86).

  * [Mark Jansen] Save size of main window and tool panels (#88).

  * Don't resize tool panels unnecessarily.

  * Fix invalid cursor state when moving between regions.

  * Fix crash when deleting data (#113, #123).

  * Fix opening files with 8-bit filenames, and other encoding issues (#117).

  * Virtual segment mapping and display (#7).

  * Display inline comments by default (didn't always work).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sun, 02 May 2021 21:09:21 +0100

rehex (0.3.1-0~ubuntu2010) groovy; urgency=low

  * Correctly display signed 16-bit values in "Decode values" panel.

  * Fix status bar offset going out of sync.

  * Move cursor when a row in the "Comments" panel is double clicked.

  * Focus document after updating position/selection via "Comments" panel.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 13 Nov 2020 22:33:10 +0000

rehex (0.3.0-0~ubuntu2010) groovy; urgency=low

  * [Mark Jansen] Use byte grouping setting from main window in diff window.

  * [Mark Jansen] Use Capstone disassembler rather than LLVM.

  * [Mark Jansen] Support disassembling 16-bit x86 machine code.

  * [Mark Jansen] Don't update tools which aren't visible.

  * [Vincent Bermel] Unhardcode linux launcher icon file type.

  * Fix an uncommon use-after-free crash when closing tabs in diff window.

  * Support for disassembling 6800/68000 and MOS6502 instruction sets
    (requires recent Capstone version).

  * [Mark Jansen] Close document when tab is clicked with middle mouse button.

  * [Mark Jansen] Don't create .rehex-meta files when there is nothing to save.

  * Implement Strings tool to find and list ASCII strings in the file.

  * Add option to calculate automatic bytes per line in whole byte groups.

  * Add "Fill range" tool for overwriting ranges of bytes with a pattern.

  * Preserve column alignment after comments.

  * [Mark Jansen] Mark a document dirty if highlighting is changed.

  * Add data type annotations.

  * Show ranges marked as integers in their decoded form in the hex view.

  * Performance improvements for documents with large numbers of comments.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Tue, 10 Nov 2020 13:20:11 +0000

rehex (0.2.0-0~ubuntu2010) UNRELEASED; urgency=low

  * Allow copying comments from a document and pasting them elsewhere in the
    same document or into another one.

  * Fixed bounds check when clicking on nested comments in a document.

  * Added context menu when right clicking on a comment in a document.

  * Optionally highlight byte sequences which match the current selection.
    ("Highlight data matching selection" or "PatternMatchHighlight").

  * Allow copying cursor offset from document context menu.

  * Correctly display offsets over 4GiB in the status bar.

  * Display offsets as XXXX:XXXX rather than XXXXXXXX:XXXXXXXX when the file
    size is under 4GiB.

  * Add per-document option for dec/hex offset display.

  * When first byte after a comment is deleted, show that the comment was


=== debian/control ===
Source: rehex
Priority: extra
Maintainer: Daniel Collins <solemnwarning@solemnwarning.net>
Build-Depends:
 libcapstone-dev,
 debhelper (>= 9),
 libgtk-3-dev,
 libjansson-dev,
 libwxgtk3.0-gtk3-dev,
 liblua5.3-dev,
 libunistring-dev,
 lua5.3,
 pkg-config,
 xauth,
 xvfb,
 wx3.0-headers,
 zlib1g-dev
Standards-Version: 3.9.4
Section: editors
Homepage: https://github.com/solemnwarning/rehex/

Package: rehex
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libcapstone4,
 libjansson4,
 liblua5.3-0,
 libunistring2,
 libwxgtk3.0-gtk3-0v5,
 zlib1g
Description: Reverse Engineers' Hex Editor

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export prefix := /usr

# Snapshot builds are performed using source packages generated by git-buildpackage, which lack
# the .git/ directory. The Buildkite job does a changelog bump using the Git commit SHA, which we
# must then pull back out and stick in the environment for the Makefile.
#
# This hack is better or worse than maintaining upstream tar in the Git repo and import-orig'ing
# the result of 'make dist' before kicking off the snapshot build, depending on your point of view.

GIT_COMMIT_SHA = $(shell dpkg-parsechangelog --show-field Version | grep + | cut -d+ -f2 | cut -d- -f1)
ifneq ($(GIT_COMMIT_SHA),)
	export GIT_COMMIT_SHA
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKE_J_FLAG = -j$(NUMJOBS)
endif

%:
	dh $@

override_dh_auto_test:
	xvfb-run -a -e /dev/stdout make $(MAKE_J_FLAG) check

## rehex 0.5.3

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # Reverse Engineer's Hex Editor
-# Copyright (C) 2017-2021 Daniel Collins <solemnwarning@solemnwarning.net>
+# Copyright (C) 2017-2022 Daniel Collins <solemnwarning@solemnwarning.net>
 #
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License version 2 as published by
@@ -23,6 +23,7 @@
 EXE ?= rehex
 EMBED_EXE ?= ./tools/embed
 GTKCONFIG_EXE ?= ./tools/gtk-config
+HELP_TARGET ?= help/rehex.htb
 
 # Wrapper around the $(shell) function that aborts the build if the command
 # exits with a nonzero status.
@@ -32,20 +33,47 @@
 		$(wordlist 1, $(shell echo $$(($(words $(sod_out)) - 1))), $(sod_out)),$\
 		$(error $(1) exited with status $(lastword $(sod_out))))
 
-WX_CXXFLAGS ?= $(call shell-or-die,$(WX_CONFIG) --cxxflags base core aui propgrid adv)
-WX_LIBS     ?= $(call shell-or-die,$(WX_CONFIG) --libs     base core aui propgrid adv)
-
-CAPSTONE_CFLAGS ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --cflags)
-CAPSTONE_LIBS   ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --libs)
-
-JANSSON_CFLAGS ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --cflags)
-JANSSON_LIBS   ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --libs)
-
-LUA_CFLAGS ?= $(call shell-or-die,pkg-config $(LUA_PKG) --cflags)
-LUA_LIBS   ?= $(call shell-or-die,pkg-config $(LUA_PKG) --libs)
-
-GTK_CFLAGS = $$($(GTKCONFIG_EXE) --cflags)
-GTK_LIBS   = $$($(GTKCONFIG_EXE) --libs)
+# Check if we are building target(s) that don't need to compile anything and
+# skip fetching compiler flags from wx-config/pkg-config/etc if so, this avoids
+# having to have our dependencies on build hosts that are going to use a chroot
+# or other container for doing the actual build.
+
+NONCOMPILE_TARGETS=clean distclean dist
+
+need_compiler_flags=1
+ifneq ($(MAKECMDGOALS),)
+	ifeq ($(filter-out $(NONCOMPILE_TARGETS),$(MAKECMDGOALS)),)
+		need_compiler_flags=0
+	endif
+endif
+
+ifeq ($(BUILD_HELP),)
+	BUILD_HELP=1
+endif
+
+ifeq ($(BUILD_HELP),0)
+	HELP_TARGET :=
+else
+	HELP_CFLAGS := -DBUILD_HELP
+	HELP_LIBS := html
+endif
+
+ifeq ($(need_compiler_flags),1)
+	WX_CXXFLAGS ?= $(call shell-or-die,$(WX_CONFIG) --cxxflags base core aui propgrid adv $(HELP_LIBS))
+	WX_LIBS     ?= $(call shell-or-die,$(WX_CONFIG) --libs     base core aui propgrid adv $(HELP_LIBS))
+	
+	CAPSTONE_CFLAGS ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --cflags)
+	CAPSTONE_LIBS   ?= $(call shell-or-die,pkg-config $(CAPSTONE_PKG) --libs)
+	
+	JANSSON_CFLAGS ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --cflags)
+	JANSSON_LIBS   ?= $(call shell-or-die,pkg-config $(JANSSON_PKG) --libs)
+	
+	LUA_CFLAGS ?= $(call shell-or-die,pkg-config $(LUA_PKG) --cflags)
+	LUA_LIBS   ?= $(call shell-or-die,pkg-config $(LUA_PKG) --libs)
+	
+	GTK_CFLAGS = $$($(GTKCONFIG_EXE) --cflags)
+	GTK_LIBS   = $$($(GTKCONFIG_EXE) --libs)
+endif
 
 ifeq ($(DEBUG),)
 	DEBUG=0
@@ -57,9 +85,19 @@
 	DEBUG_CFLAGS := -ggdb
 endif
 
-CFLAGS          := -Wall -std=c99   -I. -Iinclude/ -IwxLua/modules/ $(DEBUG_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(CFLAGS)
-CXXFLAGS_NO_GTK := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ $(DEBUG_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(CXXFLAGS)
-CXXFLAGS        := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ $(DEBUG_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(GTK_CFLAGS) $(CXXFLAGS)
+ifeq ($(PROFILE),)
+	PROFILE=0
+endif
+
+ifeq ($(PROFILE),0)
+	PROFILE_CFLAGS :=
+else
+	PROFILE_CFLAGS := -DREHEX_PROFILE
+endif
+
+CFLAGS          := -Wall -std=c99   -I. -Iinclude/ -IwxLua/modules/ -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(CFLAGS)
+CXXFLAGS_NO_GTK := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(CXXFLAGS)
+CXXFLAGS        := -Wall -std=c++11 -I. -Iinclude/ -IwxLua/modules/ -DREHEX_CACHE_CHARACTER_BITMAPS $(DEBUG_CFLAGS) $(PROFILE_CFLAGS) $(HELP_CFLAGS) $(CAPSTONE_CFLAGS) $(JANSSON_CFLAGS) $(LUA_CFLAGS) $(WX_CXXFLAGS) $(GTK_CFLAGS) $(CXXFLAGS)
 
 uname_S := $(shell uname -s 2>/dev/null)
 ifeq ($(uname_S),FreeBSD)
@@ -72,7 +110,7 @@
 LDLIBS := -lunistring $(WX_LIBS) $(GTK_LIBS) $(CAPSTONE_LIBS) $(JANSSON_LIBS) $(LUA_LIBS) $(LDLIBS)
 
 # Define this for releases
-VERSION := 0.4.1
+VERSION := 0.5.3
 
 ifdef VERSION
 	LONG_VERSION := Version $(VERSION)
@@ -88,8 +126,8 @@
 	
 	GIT_COMMIT_TIME ?= $(call shell-or-die,git log -1 --format="%ct")
 	
-	VERSION      := 185c5df53fffdb6ea3625820fa3e3c6c35d57f2b
-	LONG_VERSION := Snapshot 185c5df53fffdb6ea3625820fa3e3c6c35d57f2b
+	VERSION      := 42f8b1c8f3532351221b1d1e8d4dd4f60a28713a
+	LONG_VERSION := Snapshot 42f8b1c8f3532351221b1d1e8d4dd4f60a28713a
 endif
 
 DEPDIR := .d
@@ -111,6 +149,11 @@
 .PHONY: check
 check: tests/all-tests
 	./tests/all-tests
+	
+	for p in $(PLUGINS); \
+	do \
+		$(MAKE) -C plugins/$${p} LUA=$(LUA) check || exit $$?; \
+	done
 
 .PHONY: clean
 clean:
@@ -193,6 +236,7 @@
 	wxLua/modules/wxbind/src/wxpropgrid_bind.o
 
 APP_OBJS := \
+	res/actual_size16.o \
 	res/ascii16.o \
 	res/ascii24.o \
 	res/ascii32.o \
@@ -201,6 +245,7 @@
 	res/diff_fold24.o \
 	res/diff_fold32.o \
 	res/diff_fold48.o \
+	res/fit_to_screen16.o \
 	res/icon16.o \
 	res/icon32.o \
 	res/icon48.o \
@@ -212,15 +257,22 @@
 	res/offsets32.o \
 	res/offsets48.o \
 	res/spinner24.o \
+	res/swap_horiz16.o \
+	res/swap_vert16.o \
+	res/zoom_in16.o \
+	res/zoom_out16.o \
 	src/AboutDialog.o \
 	src/AppMain.o \
+	src/AppSettings.o \
 	src/AppTestable.o \
 	src/ArtProvider.o \
 	src/BasicDataTypes.o \
+	src/BitmapTool.o \
 	src/buffer.o \
 	src/BytesPerLineDialog.o \
 	src/ByteRangeSet.o \
 	src/CharacterEncoder.o \
+	src/CharacterFinder.o \
 	src/ClickText.o \
 	src/CodeCtrl.o \
 	src/CommentTree.o \
@@ -236,12 +288,15 @@
 	src/EditCommentDialog.o \
 	src/Events.o \
 	src/FillRangeDialog.o \
+	src/IntelHexExport.o \
+	src/IntelHexImport.o \
 	src/LicenseDialog.o \
 	src/lua-bindings/rehex_bind.o \
 	src/lua-plugin-preload.o \
 	src/LuaPluginLoader.o \
 	src/mainwindow.o \
 	src/Palette.o \
+	src/profile.o \
 	src/search.o \
 	src/SelectRangeDialog.o \
 	src/StringPanel.o \
@@ -257,11 +312,12 @@
 	$(EXTRA_APP_OBJS)
 
 $(EXE): $(APP_OBJS) $(GTKCONFIG_EXE)
-	$(CXX) $(CXXFLAGS) -DLONG_VERSION='"$(LONG_VERSION)"' -DLIBDIR='"$(libdir)"' -c -o res/version.o res/version.cpp
+	$(CXX) $(CXXFLAGS) -DLONG_VERSION='"$(LONG_VERSION)"' -DLIBDIR='"$(libdir)"' -DDATADIR='"$(datadir)"' -c -o res/version.o res/version.cpp
 	$(CXX) $(CXXFLAGS) -o $@ $(APP_OBJS) res/version.o $(LDFLAGS) $(LDLIBS)
 
 TEST_OBJS := \
 	googletest/src/gtest-all.o \
+	res/actual_size16.o \
 	res/ascii16.o \
 	res/ascii24.o \
 	res/ascii32.o \
@@ -270,6 +326,7 @@
 	res/diff_fold24.o \
 	res/diff_fold32.o \
 	res/diff_fold48.o \
+	res/fit_to_screen16.o \
 	res/icon16.o \
 	res/icon32.o \
 	res/icon48.o \
@@ -281,14 +338,21 @@
 	res/offsets32.o \
 	res/offsets48.o \
 	res/spinner24.o \
+	res/swap_horiz16.o \
+	res/swap_vert16.o \
+	res/zoom_in16.o \
+	res/zoom_out16.o \
 	src/AboutDialog.o \
+	src/AppSettings.o \
 	src/AppTestable.o \
 	src/ArtProvider.o \
 	src/BasicDataTypes.o \
+	src/BitmapTool.o \
 	src/buffer.o \
 	src/ByteRangeSet.o \
 	src/BytesPerLineDialog.o \
 	src/CharacterEncoder.o \
+	src/CharacterFinder.o \
 	src/ClickText.o \
 	src/CommentTree.o \
 	src/ConsoleBuffer.o \
@@ -300,6 +364,8 @@
 	src/EditCommentDialog.o \
 	src/Events.o \
 	src/FillRangeDialog.o \
+	src/IntelHexExport.o \
+	src/IntelHexImport.o \
 	src/LicenseDialog.o \
 	src/lua-bindings/rehex_bind.o \
 	src/lua-plugin-preload.o \
@@ -315,10 +381,12 @@
 	src/util.o \
 	src/VirtualMappingDialog.o \
 	src/win32lib.o \
+	tests/BitmapTool.o \
 	tests/buffer.o \
 	tests/ByteRangeMap.o \
 	tests/ByteRangeSet.o \
 	tests/CharacterEncoder.o \
+	tests/CharacterFinder.o \
 	tests/CommentsDataObject.o \
 	tests/CommentTree.o \
 	tests/ConsoleBuffer.o \
@@ -326,6 +394,9 @@
 	tests/DisassemblyRegion.o \
 	tests/Document.o \
 	tests/DocumentCtrl.o \
+	tests/FastRectangleFiller.o \
+	tests/IntelHexExport.o \
+	tests/IntelHexImport.o \
 	tests/LuaPluginLoader.o \
 	tests/main.o \
 	tests/NestedOffsetLengthMap.o \
@@ -337,49 +408,3 @@
 	tests/SafeWindowPointer.o \
 	tests/SharedDocumentPointer.o \
 	tests/StringPanel.o \
-	tests/Tab.o \
-	tests/util.o \
-	$(WXLUA_OBJS) \
-	$(WXBIND_OBJS) \
-	$(EXTRA_TEST_OBJS)
-
-tests/all-tests: $(TEST_OBJS) $(GTKCONFIG_EXE)
-	$(CXX) $(CXXFLAGS) -DLONG_VERSION='"$(LONG_VERSION)"' -DLIBDIR='"$(libdir)"' -c -o res/version.o res/version.cpp
-	$(CXX) $(CXXFLAGS) -o $@ $(TEST_OBJS) res/version.o $(LDFLAGS) $(LDLIBS)
-
-$(EMBED_EXE): tools/embed.cpp
-	$(CXX) $(CXXFLAGS_NO_GTK) -o $@ $<
-
-$(GTKCONFIG_EXE): tools/gtk-config.cpp
-	$(CXX) $(CXXFLAGS_NO_GTK) $(WX_CXXFLAGS) -o $@ $<
-
-src/AboutDialog.o: res/icon128.h
-src/ArtProvider.o: \
-	res/ascii16.h res/ascii24.h res/ascii32.h res/ascii48.h \
-	res/diff_fold16.h res/diff_fold24.h res/diff_fold32.h res/diff_fold48.h \
-	res/offsets16.h res/offsets24.h res/offsets32.h res/offsets48.h
-src/DiffWindow.o: res/icon16.h res/icon32.h res/icon48.h res/icon64.h
-src/LicenseDialog.o: res/license.h
-src/LuaPluginLoader.o: src/lua-bindings/rehex_bind.h src/lua-plugin-preload.h
-src/mainwindow.o: res/icon16.h res/icon32.h res/icon48.h res/icon64.h
-src/StringPanel.o: res/spinner24.h
-
-res/license.done: LICENSE.txt $(EMBED_EXE)
-	$(EMBED_EXE) $< LICENSE_TXT res/license.c res/license.h
-	touch $@
-
-res/license.c res/license.h: res/license.done ;
-
-res/%.c res/%.h: res/%.png $(EMBED_EXE)
-	$(EMBED_EXE) $< $*_png res/$*.c res/$*.h
-
-res/%.c res/%.h: res/%.gif $(EMBED_EXE)
-	$(EMBED_EXE) $< $*_gif res/$*.c res/$*.h
-
-src/lua-bindings/rehex_bind.done: src/lua-bindings/rehex.i src/lua-bindings/rehex_override.hpp src/lua-bindings/rehex_rules.lua $(WXLUA_BINDINGS)
-	$(LUA) -e"rulesFilename=\"src/lua-bindings/rehex_rules.lua\"" wxLua/bindings/genwxbind.lua
-	
-	# genwxbind.lua may not modify individual files if they are already up to date.
-	touch -c src/lua-bindings/rehex_bind.cpp
-	touch -c src/lua-bindings/rehex_bind.h
-

=== debian/changelog ===
rehex (0.5.3-0~ubuntu2110) impish; urgency=low

  * Correctly nest comments when updating comments panel (#169).

  * Update text in comments panel when a comment is modified.

  * Fix display of >4GiB virtual offsets in files that are <=4GiB (#170).

  * Add support for code page 437 (IBM) and 932/936/949/950 (Microsoft).

  * Fix handling of multibyte character boundaries in document view.

  * Draw wide characters in document view (#173).

  * Move forwards/backwards and select whole instructions from disassembly
    in document view.

  * Don't capture tab key press in text area of document view.

  * Add missing error checks.

  * Add number base option to "Jump to offset" dialog.

  * Drawing optimisations (improves responsiveness), particularly on macOS.

  * Fix some undefined behaviour issues.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sat, 25 Jun 2022 17:51:37 +0100

rehex (0.5.2-0~ubuntu2110) impish; urgency=low

  * Correctly nest comments when updating comments panel (#169).

  * Update text in comments panel when a comment is modified.

  * Fix display of >4GiB virtual offsets in files that are <=4GiB (#170).

  * Add support for code page 437 (IBM) and 932/936/949/950 (Microsoft).

  * Fix handling of multibyte character boundaries in document view.

  * Draw wide characters in document view (#173).

  * Move forwards/backwards and select whole instructions from disassembly
    in document view.

  * Don't capture tab key press in text area of document view.

  * Add missing error checks.

  * Add number base option to "Jump to offset" dialog.

  * Drawing optimisations (improves responsiveness), particularly on macOS.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Fri, 24 Jun 2022 21:53:33 +0100

rehex (0.5.0-0~ubuntu2110) impish; urgency=low

  * Added "x86 disassembly syntax" to "View" menu to allow selecting between
    Intel or AT&T notation for x86 disassembly (#142).

  * Handle file open message used for "Open With" on macOS (#144).

  * Added --compare switch to jump straight into comparing two files (#141).

  * Fix timer leak that can cause a crash when closing the compare window or
    strings panel.

  * Add import and export functions for Intel Hex files (#102).

  * Add online help (#147).

  * Add Bitmap Data Visualisation tool (#29).

  * Add Binary Template support (#138).

  * [Emily Ellis] Save new files without the execute bit set (#154).

  * Include highlight colour names in context menu (#153).

  * Save write protect setting in rehex-meta.json (#143).

  * Fix several occasional crashes.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Sat, 23 Apr 2022 15:19:08 +0100

rehex (0.4.1-0~ubuntu2110) impish; urgency=low

  * Fixed font-dependent rendering glitches when control characters or other
    Unicode oddities were present in the text view.

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 03 Jan 2022 16:59:43 +0000

rehex (0.4.0-0~ubuntu2110) impish; urgency=low

  * Add data types for common text encodings (Unicode, ISO-8859) - text
    displayed or typed into the text view on the right will be decoded or
    encoded appropriately (#10).

  * Treat pasted text as text rather than a string of raw bytes.

  * Add 8-bit integer data types.

  * Don't mark new files as unsaved.

  * Store cursor position history and allow jumping backwards/forwards (#81).

  * Allow jumping to previous/next difference in data compare window (#131).

  * Collapse long ranges of identical data in data compare window (#85).

  * Added "Jump to offset in main window" to data compare window context menu.

  * Added shortcuts for comparing data (#103).

  * Add support for other encodings to strings tool (#106).

  * Add write protect flag to prevent accidental changes to file data during
    analysis (#130).

  * Respect system cursor blink speed setting (#112).

 -- Daniel Collins <solemnwarning@solemnwarning.net>  Mon, 20 Dec 2021 17:50:01 +0000

=== debian/control ===
--- 
+++ 
@@ -8,12 +8,15 @@
  libjansson-dev,
  libwxgtk3.0-gtk3-dev,
  liblua5.3-dev,
+ libtemplate-perl,
  libunistring-dev,
+ lua-busted,
  lua5.3,
  pkg-config,
  xauth,
  xvfb,
  wx3.0-headers,
+ zip,
  zlib1g-dev
 Standards-Version: 3.9.4
 Section: editors
